import sys

__all__ = ['const']

def const(nonzero=True):
    frame = sys._getframe(1)
    # only allow module-level consts
    assert frame.f_locals is frame.f_globals and '__module__' not in frame.f_locals
    mod = sys.modules[frame.f_locals['__name__']]
    return Const(None, nonzero, module=mod)

class Const(object):
    __slots__ = ('name', 'nonzero', 'module')
    def __init__(self, name, nonzero=True, module=None):
        self.name = name
        self.nonzero = nonzero
        self.module = module

    def __repr__(self):
        if self.module is None:
            assert self.name
            return self.name
        elif not self.name:
            for name, value in self.module.__dict__.iteritems():
                if value is self:
                    self.name = name
                    break
            else:
                raise AssertionError("Constant not found in the module: %r" % self.module.__name__)
        return "%s.%s" % (self.module.__name__, self.name)


    def __nonzero__(self):
        return self.nonzero
